#include "OS.CH"
#include "XBP.CH"
#include "Appevent.ch"
#include "Xbp.ch"

#define nStatSize                20
#define ZEROBASE                 0           // Zero based Index
#define GROUPBASE                1000        // GroupID Start-Base

#define CRLF                     CHR(13)+CHR(10)

#define LVGS_NORMAL              0
#define LVGS_COLLAPSED           0x01
#define LVGS_HIDDEN              0x02
#define LVGS_COLLAPSIBLE         0x00000008
#define LVGS_SELECTED            0x00000020
#define LVGS_SUBSETED            0x00000040
#define LVGS_SUBSETLINKFOCUSED   0x00000080

#define LVS_ALIGNTOP             0
#define LVGA_FOOTER_CENTER       0x10
#define LVGA_FOOTER_LEFT         0x08
#define LVGA_FOOTER_RIGHT        0x20
#define LVGA_HEADER_CENTER       0x02
#define LVGA_HEADER_LEFT         0x01
#define LVGA_HEADER_RIGHT        0x04

#define LVGF_ALIGN               0x08
#define LVGF_FOOTER              0x02
#define LVGF_GROUPID             0x10
#define LVGF_HEADER              0x01
#define LVGF_NONE                0
#define LVGF_STATE               0x04

PROCEDURE Appsys
RETURN

PROCEDURE Main
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg
LOCAL oDXElist, oStat
LOCAL aSize    := {800,600}
LOCAL aTitle   := {"Column 1","Column 2"}
LOCAL aColWide := {390,390}
LOCAL nID,cHeader,cFooter
LOCAL aGroup,i,iMax
LOCAL nRet
LOCAL dwState
LOCAL dwAlign

   oDlg           := XbpDialog():new(AppDesktop(),,{0,0},aSize)
   oDlg:title     := "ListView Group"
   oDlg:titlebar  := .T.
   oDlg:tasklist  := .T.
   oDlg:icon      := 1001
   oDlg:drawingArea:Resize := {|aOld,aNew,oSelf| MainResize(aOld,aNew,oSelf) }
   oDlg:create()

   CenterControl(oDlg)
   oDlg:show()

   * ------------------------------------------------------------------ *

   aSize    := oDlg:drawingArea:Currentsize()
   aSize[2] -= nStatSize

   oStat := XbpStatic():New(oDlg:drawingArea,,{0,0},{aSize[1],nStatSize} )
   oStat:Create()
   oStat:Cargo := "me"

   * ------------------------------------------------------------------ *

   // most Sample say use LVS_ALIGNTOP ...
   //
   oDXElist := DXE_LVGroup():new(oDlg:drawingArea,,{0,nStatSize},aSize,,,LVS_ALIGNTOP)
   oDXElist:aTitle         := aTitle
   oDXElist:aColWide       := aColWide
   oDXElist:FullRowSelect  := .T.
   oDXElist:GridLines      := .T.

   // use Icon from Resource
   //
   oDXElist:luseIcon       := .T.
   oDXElist:cDllName       := "LVGROUP.EXE"

   * ------------------------------------------------------------------ *

   oDXElist:create()
   oDXElist:itemSelected   := {|n,nSub,oSelf| DoGetItem(n,nSub,oSelf) }
   oDXElist:itemMarked     := {|n,nSub,oSelf| DoGroup(n,nSub,oSelf,oStat) }
*  oDXElist:itemRbDown     := {|n,nSub,oSelf| DoMenu(n,nSub,oSelf) }

   * ------------------------------------------------------------------ *

   // need to add 1 Line Dummy ?
   //
   // Syntax
   // :AddItem(cText,nMask,nIItem,nIImage,nISubItem,xIndent,nGroup)
   //
   oDXElist:addItem("Test 1.1"  ,,0,     ,0,,0)

   * ------------------------------------------------------------------ *

   // enable Groupview
   //
   nRet := oDXElist:EnableGroupView()

   dwState  := bOR(LVGS_COLLAPSIBLE,LVGS_NORMAL)
   dwAlign  := LVGA_HEADER_LEFT

   * ------------------------------------------------------------------ *

   nID      := GROUPBASE+1
   cHeader  := "Header 1"
   cFooter  := "Footer 1"
   nRet     := oDXElist:InsertGroupHeader(-1,nID,cHeader,dwState, dwAlign)

   oDXElist:SetGroupTask(    nID, "Task 1")
   oDXElist:SetGroupSubtitle(nID, "Subtitle 1")
   oDXElist:SetGroupFooter(  nID, cFooter)

   // Syntax
   // :AddToGroup(cText,nMask,nIItem,nIImage,nISubItem,xIndent,nGroup)
   //
   oDXElist:AddToGroup("Group 1.0",,1,1001,,,nID)
   oDXElist:AddToGroup("Group 1.1",,2,1001,,,nID)
   oDXElist:AddToGroup("Group 1.2",,3,1001,,,nID)

   oDXElist:AddToGroup("Group 1.0.2",,1,,1,,nID)
   oDXElist:AddToGroup("Group 1.1.2",,2,,1,,nID)
   oDXElist:AddToGroup("Group 1.2.2",,3,,1,,nID)

   oDXElist:SetGroupTitleImage(GROUPBASE+1,oDXElist:GetMaxIcon())

   * ------------------------------------------------------------------ *

   nID      := GROUPBASE+2
   cHeader  := "Header 2"
   cFooter  := "Footer 2"
   nRet     := oDXElist:InsertGroupHeader(-1,nID,cHeader,dwState, dwAlign)

   oDXElist:SetGroupTask(    nID, "Task 2")
   oDXElist:SetGroupSubtitle(nID, "Subtitle 2" )
   oDXElist:SetGroupFooter(  nID, cFooter)

   oDXElist:AddToGroup("Group 2.0",,4,1002,,,nID)
   oDXElist:AddToGroup("Group 2.1",,5,1002,,,nID)
   oDXElist:AddToGroup("Group 2.2",,6,1002,,,nID)

   oDXElist:SetGroupTitleImage(GROUPBASE+2,oDXElist:GetMaxIcon())

   * ------------------------------------------------------------------ *

   nID      := GROUPBASE+3
   cHeader  := "Header 3"
   cFooter  := "Footer 3"
   nRet     := oDXElist:InsertGroupHeader(-1,nID,cHeader,dwState, dwAlign)

   oDXElist:SetGroupTask(    nID, "Task 3")
   oDXElist:SetGroupSubtitle(nID, "Subtitle 3" )
   oDXElist:SetGroupFooter(  nID, cFooter)

   oDXElist:AddToGroup("Group 3.0",,7,1003,,,nID)
   oDXElist:AddToGroup("Group 3.1",,8,1003,,,nID)
   oDXElist:AddToGroup("Group 3.2",,9,1003,,,nID)

   oDXElist:SetGroupTitleImage(GROUPBASE+3,oDXElist:GetMaxIcon())

   * ------------------------------------------------------------------ *

*  oDXElist:GroupItemCount()
   oDXElist:InitImageView()

   oDXElist:show()
   setAppFocus(oDXElist)

   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp)
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

* ---------------------------------------------------------------------- *

PROCEDURE MainResize(aOld,aNew,oSelf)
LOCAL aChild
LOCAL i,iMax
LOCAL aColwide,n,nLen

   IF aOld[1] == 0 .AND. aOld[2] == 0              // was minimize
      aOld := aNew                                 // New Size

   ELSEIF aNew[1] == 0 .OR. aNew[2] == 0           // is now minimized
      RETURN

   ELSEIF aNew[1] == aOld[1] .AND. aNew[2] == aOld[2]
      RETURN                                       // same Size
   ENDIF

   oSelf:lockUpdate(.T.)

   aChild := oSelf:Childlist()
   iMax := LEN(aChild)
   FOR i := 1 TO iMax
      DO CASE
         CASE aChild[i]:isDerivedFrom("DXE_LVGroup") .AND. EMPTY(aChild[i]:Cargo)
              aChild[i]:SetPos({0,30})
              aChild[i]:SetSize({aNew[1],aNew[2]-nStatSize})

              aColwide := aChild[i]:GetColWide()
              nLen := LEN(aColwide)
              FOR n := 1 TO nLen
                  aColwide[n] := aNew[1]/nLen
              NEXT
              aChild[i]:SetColWide( aColwide )

         CASE aChild[i]:isDerivedFrom("XbpStatic") .AND. !EMPTY(aChild[i]:Cargo)
              aChild[i]:SetPos({0,0})
              aChild[i]:SetSize({aNew[1],nStatSize})
      ENDCASE
   NEXT

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN

* ---------------------------------------------------------------------- *

PROCEDURE DoGetItem(n,nSub,oSelf)
   Msgbox(VAR2CHAR(oSelf:GetItemText(n,nSub)))
RETURN

* ---------------------------------------------------------------------- *

PROCEDURE DoGroup(n,nSub,oSelf,oStat)
LOCAL oLVGROUP
LOCAL nState
LOCAL i, iMax
LOCAL nGroupId
LOCAL nRet    := -99
LOCAL lExpand := .F.

   IF n > GROUPBASE

      oLVGROUP := oSelf:GetStructure()
      oLVGROUP:cbSize := oLVGROUP:_sizeof_()
      oLVGROUP:mask   := LVGF_STATE

      nRet := oSelf:GetGroupState(n, LVGS_COLLAPSED)
      IF nRet <> 0
         nState  := LVGS_NORMAL
         lExpand := .T.
      ELSE
         nState  := LVGS_COLLAPSED
         lExpand := .F.
      ENDIF

      oLVGROUP:State     := nState
      oLVGROUP:stateMask := nState
      nRet := oSelf:SetGroupInfo(n, oLVGROUP)

      // if Expand we need check Items
      //
      IF lExpand = .T.
         iMax := oSelf:GetItemCount()
         FOR i := 1 TO iMax
            nGroupId := oSelf:GetRowGroupId(i)
            IF (nGroupId != -1)
            ELSE
               IF oSelf:HasGroupState(nGroupId,LVGS_COLLAPSED)
               ELSE
                  oSelf:SetGroupState(nGroupId,LVGS_NORMAL)
               ENDIF
            ENDIF
         NEXT
      ENDIF
   ELSE
     oStat:SetCaption(VAR2CHAR(oSelf:GetItemText(n,nSub)))
   ENDIF

RETURN

* ---------------------------------------------------------------------- *

PROCEDURE DoMenu(n,nSub,oSelf)
// under construction
RETURN
* ---------------------------------------------------------------------- *

*
* eof
*